/*
    gopher probing plugin for SrvCheck.
    Copyright (C) Mateusz Viste 2010,2011,2012. All rights reserved.
*/

void SrvCheck_gopher(int sock, char *ErrString, int ErrString_maxlen) {
  char answer[1024];
  int recvBytes;
  if (send(sock, "\r\n", 2, 0) < 0) {
      snprintf(ErrString, ErrString_maxlen, "connection interrupted while sending the request / %s", strerror(errno));
    } else { /* receive the answer */
      recvBytes = recv(sock, answer, 1024, 0);
      if (recvBytes < 0) {
          snprintf(ErrString, ErrString_maxlen, "connection interrupted while receiving the answer / %s", strerror(errno));
        } else if (recvBytes == 0) {
          snprintf(ErrString, ErrString_maxlen, "the server returned no data");
      }
    }
}
